
/*********************************************************************
	Bench.c - A program with variousBenchmarks
	12/10/99
	Runs on AMD 188ES or 186ES Tern Controller

	Note: The makefile had to be modifed to set FLOAT equal to 2
	to enable the floating point emulator.

	Test: This program was run with an AMD 188ES at 40 MHz
	      and then again with a 186ES at 40 MHz. Breakpoints
	      were set after each test and the execution time tested
	      with a stop watch.

*********************************************************************/
#include  "ae.h"   // AE88 initialization */
#include  "math.h"
#include "float.h"

 void floatingatan(float x,int n);
 void seive(long int n);
 void floatingmul(float x, int n);
 void floatingadd(float x, int n);
 void emptyloop(float x, int n);
 void floatingadd(float x, int n);
 void floatingdiv(float x, int n);
 void floatingsqrt(float x, int n);
 void floatingsin(float x, int n);
 void floatingexp(float x, int n);
 void floatingatan(float x, int n);
 void floatinglog(float x, int n);
 outport ( unsigned __portid, unsigned __value );






void main(void)
{
auto int i,j,k;
auto float x,y,z,time,emptytime;
auto unsigned long timer1,timer2;
int n;


	ae_init();       /* A-Engine initialization */
	outport(0xffa2,0x7fbc); // make sure 0 wait states


   // time the seive program, a test of integer operations

 n=400;

 ;
 seive(n);

// seive -  188 40 mhz - 48 sec .120 sec / iteration

  // *** n must be multiple of 1000 in following tests
 
 n=5000;

 emptyloop(1.,n);

 // empty loop - 188 21 sec - 4.2 us / iteration



 n=100;

 floatingmul(7.6834,n);

 // floating mul - 188 18 sec - 180-4= 180 us / operation




 n=100;

 floatingadd(7.6834,n);

 // floating add - 188 16 sec - 160-4=160 us / op


    n=100;

 floatingdiv(7.6834,n);


// floating div - 19 sec - 190-4=190 us / op

  n=100;

 floatingsqrt(7.6834,n);

// floating sqrt - 188 33 sec - 330-4= 330 us / op
 n=50;

 floatingsin(.3,n);

// floating sin - 188 37 sec - 740-4 = 740 us / op

 
 n=20;

 floatingexp(.3,n);

 // floating exp - 188 25 sec - 1250-4= 1250 us / op


 n=20;

 floatinglog(.3,n);

 // floating log - 188 21 sec - 1050-4 = 1050 us / op


 n=20;

 floatingatan(.3,n);

 // floating atan - 188 22 sec - 1100-4 -1100 us / op


  }


 float xxn[]={1.34897,5.67e-4,9234.564,8.564,456.33e5,1.0002,.0003467,1000.0034};
 float ttn[]={.01,.2, .4, .8, 1.002, -1.5324, 1.678, -.93}; // angles
 float ttl[]={ 1e20, 34., 1.02, 45., 22222., 1e30, 50000., 5666.} ; // numbers to log
 
void floatingsin(float x, int n){
 auto int i,k,j;
 float y,z;
 
 
 for(i=0; i<n; i++) {
   // inner loop
   x=ttn[i&7];
   for (k=0; k<1000; k++){
 
     y=sin(x); // null operation
   
   }
 }
} // return

void floatingexp(float x,  int n){
 auto int i,k,j;
 float y,z;
 

 for(i=0; i<n; i++) {
   // inner loop
   x=ttn[i&7];
   for (k=0; k<1000; k++){
 
     y=exp(x); // null operation
   
   }
 }
} // return

void floatinglog(float x,  int n){
 auto int i,k,j;
 float y,z;
 
 
 for(i=0; i<n; i++) {
   // inner loop
   x=ttl[i&7];
   
   for (k=0; k<1000; k++){
 
     y=log(x); // null operation
   
   }
 }
} // return

 
void floatingatan(float x,  int n){
 auto int i,k,j;
 float y,z;
 
 
 for(i=0; i<n; i++) {
   // inner loop
   x=ttn[i&7]; // angles
   for (k=0; k<1000; k++){
 
     y=atan(x); // null operation
   
   }
 }
} // return



void floatingsqrt(float x, int n){
 auto int i,k,j;
 float y,z;
 
 
 
 
 for(i=0; i<n; i++) {
   // inner loop
   x=xxn[i&7];
   for (k=0; k<1000; k++){
 
     y=sqrt(x); // add operation
   
   } // k
    
 } // i
} // return
  






void emptyloop(float x,  int n){
 auto int i,k,j;
 float y,z;
 

 for(i=0; i<n; i++) {
   // inner loop
   for (k=0; k<1000; k++){
 
     y=x; // null operation
   
   }
 }
} // return


 void  floatingadd(float x,  int n){
 auto int i,k,j;
 float y,z;
 
  
 
 for(i=0; i<n; i++) {
   // inner loop
   x=xxn[i&7]; y=xxn[(i+i+1)&7];
   
   for (k=0; k<1000; k++){
 
     z=x+y; // add operation
   
   } // k
   
 } // i
} // return
  
  
void floatingmul(float x,  int n){
 auto int i,k,j;
 float y,z;
  x=xxn[i&7]; y=xxn[(i+i+1)&7];
 
 for(i=0; i<n; i++) {
   // inner loop
  
   for (k=0; k<1000; k++){
 
     z=x*y; // mul operation
   
   }
 }
} // return


void  floatingdiv(float x, int n){
 auto int i,k,j;
 float y,z;

  x=xxn[i&7]; y=xxn[(i+i+1)&7];
 for(i=0; i<n; i++) {
   // inner loop

   for (k=0; k<1000; k++){
 
     z=x/y; // divide operation
    
   } // k
 } // i
} // return



    
void seive(long int n)  /* compute prines using seive of Eratosthenes*/
/* seive test program*/


#define SIZE 8190
#define FALSE 0
#define TRUE 1
//#define NTIMES 50


{
auto int i,j,k,count,prime,NTIMES;
static char flag[SIZE+1];

//printf("100 iterations: ");
NTIMES=n;

for (i=1; i<=NTIMES; i++)
	{
	count=0;
	for (j=0; j<=SIZE; j++) flag[j]=TRUE;
	for (j=0; j<=SIZE; j++)
		{if(flag[j])
			{
			prime=2*j+3;
			for(k=j+prime; k<= SIZE; k+=prime)
				flag[k]=FALSE; /*discard multiples*/
			count++;
			}
		}
	}
//printf("%d primes.\n",count);

}


